package ch.mollusca.stomp;

import scala.actors._
import scala.actors.Actor._
import ch.mollusca.stomp.actors._
import java.net._
import java.io._


case object Close

class StompBroker extends Actor {
  private var running = true
  private val socketActor = new SocketActor(61616).start

  def act() {
    loopWhile(running) {
      react {
        case Close => running = false
      }
    }
  }
 
  
  private class SocketActor(serverPort: Int) extends Actor {
    def act() = {
      println("Opening server socket on port " + serverPort)
      val serverSocket = new ServerSocket(serverPort)
      println("listening intently for client connections...")
      
      while(running) {
        val clientSocket = serverSocket.accept()
        println("new client connection from ")
        new ClientActor(clientSocket.getInputStream(), clientSocket.getOutputStream).start
      }
    }
  }
}

object StompBroker {
  def main(args : Array[String]) : Unit = {
    val broker = new StompBroker()
    broker.start()
    broker ! Close
  }
}

